import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 08.08.2008
  * @author Daniel Garmann
  */

public class Gui extends JFrame {
  // Anfang Attribute
  private Graph graph;
  
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JButton jButton1 = new JButton();
  private JTextField jTextField1 = new JTextField();
  private JTextField jTextField2 = new JTextField();
  private JButton jButton2 = new JButton();
  private JTextArea jtaMatrix = new JTextArea("");
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super (title);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    int frameWidth = 514;
    int frameHeight = 295;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jLabel1.setBounds(16, 8, 84, 16);
    jLabel1.setText("Knoten:");
    jLabel1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel1);
    jLabel2.setBounds(152, 8, 100, 16);
    jLabel2.setText("Kanten:");
    jLabel2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel2);
    jButton1.setBounds(40, 72, 187, 25);
    jButton1.setText("Graph bernehmen");
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1_ActionPerformed(evt);
      }
    });
    cp.add(jButton1);
    jTextField1.setBounds(16, 32, 105, 24);
    jTextField1.setText("A,B,C,D,E,F");
    cp.add(jTextField1);
    jTextField2.setBounds(152, 32, 313, 24);
    jTextField2.setText("AB5,BC5,CD5,DE5,EF5,FA5,AC1,CE1,EB1,BD1");
    cp.add(jTextField2);
    jButton2.setBounds(40, 104, 187, 25);
    jButton2.setText("Adjazenzmatrix ->");
    jButton2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton2_ActionPerformed(evt);
      }
    });
    cp.add(jButton2);
    jtaMatrix.setText("(Strings)");
    jtaMatrix.setBounds(256, 72, 225, 177);
    cp.add(jtaMatrix);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  public void jButton1_ActionPerformed(ActionEvent evt) {
    // Graph bernehmen
    graph = new Graph();
    
    String s = jTextField1.getText();
    String knoten[] = s.split(",");
    for (int i=0; i< knoten.length; i++){
      String b = ""+knoten[i].charAt(0);
      graph.addNode(new GraphNode(b));
    }

    s = jTextField2.getText();
    String kanten[] = s.split(",");
    for (int i=0; i< kanten.length; i++){
      char b1 = kanten[i].charAt(0);
      GraphNode k1 = graph.getNode(""+b1);
      char b2 = kanten[i].charAt(1);
      GraphNode k2 = graph.getNode(""+b2);
      double laenge = Double.parseDouble(kanten[i].substring(2,kanten[i].length()));
      graph.addEdge(k1, k2,laenge);
    }
  }


  public double[][] adjazenzmatrix(Graph g) {
    String alleNamen = "";
    List nodes = g.getNodes();
    for (nodes.toFirst(); nodes.hasAccess(); nodes.next()) {
      alleNamen = alleNamen + ";" + ((GraphNode)(nodes.getObject())).getName();
    }
    alleNamen = alleNamen.substring(1);
    String[] namen = alleNamen.split(";");
    int knotenanzahl = namen.length;
    double[][] matrix = new double[knotenanzahl][knotenanzahl];
    for (nodes.toFirst(); nodes.hasAccess(); nodes.next()) {
      GraphNode von = (GraphNode)(nodes.getObject());
      List neighbours = g.getNeighbours(von);
      for (neighbours.toFirst(); neighbours.hasAccess(); neighbours.next()) {
        GraphNode nach = (GraphNode)neighbours.getObject();
        int vonNr = 0;
        int nachNr = 0;
        for (int k = 0; k < knotenanzahl; k++) {
          if (namen[k].equals(von.getName())) {
            vonNr = k;
          } else if (namen[k].equals(nach.getName())) {
            nachNr = k;
          }
        }
        matrix[vonNr][nachNr] = g.getEdgeWeight(von, nach);
      }
    }
    return matrix;
  }
  
  public void jButton2_ActionPerformed(ActionEvent evt) {

    double[][] matrix = adjazenzmatrix(graph);

    jtaMatrix.setText("");
    for (int y = 0; y < matrix.length; y++) {
      String s = "| ";
      for (int x = 0; x < matrix.length; x++) {
        s = s + matrix[x][y] + " | ";
      }
      jtaMatrix.append(s+"\r\n");
    }
    
    
  }

  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Gui");
  }
}
